<template>
  <q-header v-if="store.state.user._id" elevated class="text-white" style="background: #24292e;position:sticky" height-hint="61.59">
    <q-toolbar class="q-py-sm q-px-md">
      <q-drawer v-model="drawer">
        <q-toolbar style="background: #24292e">
          <img src="../assets/img/general/logo.png" alt="">
          <q-space/>
          <q-btn round
                 flat
                 icon="keyboard_arrow_left"
                 class="WAL__drawer-open q-mr-sm"
                 @click="drawer = false"
          />
        </q-toolbar>
        <q-list dark>
          <router-link
              v-for="p in page"
              :key="'page-'+p.component"
              :to="{name: p.component}"
          >
            <q-item
                clickable
                dark
                class="flex items-center text-black"
            >
              {{p.name}}
            </q-item>
          </router-link>
        </q-list>
      </q-drawer>
      <q-btn v-if="$q.screen.width < 930" @click="drawer = true" round dense flat icon="menu" size="15px" color="white" class="q-mr-sm" no-caps />

      <router-link to="/"><img src="../assets/img/general/logo.png" alt="">new</router-link>

      <div v-if="$q.screen.width > 930" class="GL__toolbar-link q-ml-xs q-gutter-md text-body2 text-weight-bold row items-center no-wrap">
        <router-link to="/">
          <q-btn :outline="route.path === '/'" label="Сделки" :size="$q.screen.gt.xs && 'sm' || 'md'" class="text-white" />
        </router-link>
        <router-link :to="{name: 'Documents'}">
          <q-btn
              :outline="route.name === 'Documents'"
              label="Документация"
              :size="$q.screen.gt.xs && 'sm' || 'md'"
              class="text-white"/>
        </router-link>
        <router-link :to="{name: 'Task'}">
          <q-btn
              :outline="route.name === 'Task'"
              label="Задачи"
              :size="$q.screen.gt.xs && 'sm' || 'md'"
              class="text-white" />
        </router-link>
        <router-link :to="{name: 'Analytics'}">
          <q-btn
              :outline="route.path === '/analytics'"
              label="Аналитика"
              :size="$q.screen.gt.xs && 'sm' || 'md'"
              class="text-white"  />
        </router-link>
        <router-link v-if="roleMiddleware(['ADMIN', 'suHOS', 'HOS'])" to="/settings">
          <q-btn
              :outline="route.path === '/settings'"
              label="Настройки"
              :size="$q.screen.gt.xs && 'sm' || 'md'"
              class="text-white" />
        </router-link>
        <router-link to="/notice">
          <q-btn
              :outline="route.path === '/notice'"
              label="Объявления"
              :size="$q.screen.gt.xs && 'sm' || 'md'"
              class="text-white" />
        </router-link>
      </div>

      <q-space />

      <div class="q-pl-sm q-gutter-sm row items-center no-wrap">
        <q-btn v-if="$q.screen.gt.xs" dense flat round size="sm" icon="notifications" />
        <q-btn v-if="$q.screen.gt.xs" dense flat>
          <div class="row items-center no-wrap">
            <q-icon name="add" size="20px" />
            <q-icon name="arrow_drop_down" size="16px" style="margin-left: -2px" />
          </div>
          <q-menu v-if="1===2" auto-close>
            <q-list dense style="min-width: 100px">
              <q-item clickable class="GL__menu-link">
                <q-item-section>New repository</q-item-section>
              </q-item>
              <q-item clickable class="GL__menu-link">
                <q-item-section>Import repository</q-item-section>
              </q-item>
              <q-item clickable class="GL__menu-link">
                <q-item-section>New gist</q-item-section>
              </q-item>
              <q-item clickable class="GL__menu-link">
                <q-item-section>New organization</q-item-section>
              </q-item>
              <q-separator />
              <q-item-label header>This repository</q-item-label>
              <q-item clickable class="GL__menu-link">
                <q-item-section>New issue</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </q-btn>

        <q-btn dense flat no-wrap>
          <q-avatar rounded size="20px">
            <img src="https://cdn.quasar.dev/img/avatar3.jpg">
          </q-avatar>
          <div class="q-px-sm">{{store.state.user && store.state.user.username || '' }}</div>
          <q-icon name="arrow_drop_down" size="16px" />

          <q-menu auto-close>
            <q-list dense>
              <router-link :to="{name: 'Profile'}" style="color: initial">
                <q-item clickable class="GL__menu-link">
                  <q-item-section>Мой профиль</q-item-section>
                </q-item>
              </router-link>
              <q-item clickable class="GL__menu-link">
                <q-item-section>Настройки</q-item-section>
              </q-item>
              <q-separator />
              <q-item @click="logout" clickable class="GL__menu-link">
                <q-item-section>Выход</q-item-section>
              </q-item>
            </q-list>
          </q-menu>
        </q-btn>
      </div>
    </q-toolbar>
  </q-header>
</template>

<script>
import Modal from "./Modal.vue";
import LoadsSpinner from "./Loads-spinner.vue";
import {ref, watch, onMounted} from "vue";
import axios from "axios";
import {useStore} from "vuex";
import {useRoute} from "vue-router";
import api from "../API/api.js";
import router from "../router";
import {roleMiddleware} from './roleMiddleware'
export default {
  name: "Header",
  components: {LoadsSpinner, Modal},
  setup() {
    const store = useStore()
    const route = useRoute()
    async function logout () {
      store.state.user = {}
      store.state.token = ''
      localStorage.removeItem('token')
      localStorage.removeItem('user')
      await router.replace('/login')
    }

    onMounted(() => {
      // console.log(route.path)
    })

    return {
      roleMiddleware,
      page: [
        {name: 'Лиды', component: 'Index'},
        {name: 'Документация', component: 'Documents'},
        {name: 'Задачи', component: 'Task'},
        {name: 'Аналитика', component: 'Analytics'},
        {name: 'Настройки', component: 'Settings'},
        {name: 'Объявления', component: 'Notice'},
      ],
      logout,
      store,
      route,
      drawer: ref(false)
    }
  }
}
</script>

<style scoped lang="scss">
.search {
  position: relative;
  margin-bottom: 20px;
  input {
    border-bottom: 1px solid #b0b0b0;
    padding-left: 5px;
    display: block;
    &::placeholder {
      font-size: 14px;
      opacity: 0.5;
    }
    &:active, &:hover, &:focus {
      outline: 0;
      outline-offset: 0;
      border-bottom: 1px solid black;
    }
  }
  &:before {
    display: block;
    background: url("../assets/img/icons/magnify.png") center;
    position: absolute;
    width: 20px;
    height: 20px;
  }
}
</style>
